#!/usr/bin/perl

# written by Jason Rennie <jr6b+@andrew.cmu.edu> for ifile

# knowledge_base.mh is a wrapper for ifile which is specific to the MH
# environment.  It uses ifile to collect word statistics on all mail files
# which are stored in the user's MH mail directories.  

$ifile_args = "-h -v 2";
$ifile_binary = "ifile";
$folders_file = ".folders";

################################
# gets environment information #
################################

$home_dir = $ENV{"HOME"}."/";

open(MH, "< $home_dir.mh_profile");

while (<MH>) {
    if (m/^path:\s*(\S+)/i) {
	$mail_path = $1;
	$mail_path .= "/";
	# if mail path is not absolute, make it so
	if ($mail_path =~ m/^[^\/]/) {
	    $mail_path = $home_dir.$mail_path;
	}
    }
}
close(MH);

if (! $mail_path) {
    $mail_path = $home_dir."Mail/";
}

$folders_file = $mail_path."/".$folders_file;

# reset old word statistics
print "$ifile_binary -r\n";
system "$ifile_binary -r";

open(FOLDER, $folders_file)
    || die "Could not open $folders_file: $!\n";
foreach $folder (<FOLDER>)
{
    chop $folder;
    if (! -f "${mail_path}$folder/.skip_me")
    {
	print "$ifile_binary $ifile_args -i $folder ${mail_path}$folder/*\n";
	system "$ifile_binary $ifile_args -i $folder ${mail_path}$folder/*";
    }
}
close(FOLDER);
    
